<template>
  <div class="account-price__header">
    <div class="account-price__header-title">
      <p>{{ order.type === STEP.BOOKING ? 'Букинг-запрос' : 'Аукцион' }}</p>
    </div>
    <div class="account-price__header-number">
      <p>
        <a  @click="goToOrder">{{ order.number }}</a>
      </p>
    </div>
    <div v-if="showCancel" class="account-price__header-menu">
      <ObMenuDropdown :items="dropdownTabs"/>
    </div>
  </div>
</template>

<script>
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
  import {mapGetters} from "vuex";
  import STEPS from '@/constants/steps.js';

  export default {
    name: "header-price",
    components: {
      ObMenuDropdown
    },
    data() {
      return {
        STEP: STEPS
      }
    },
    computed: {
      ...mapGetters({
        order: 'account/order',
        contractorUuid: 'user/participantUuid'
      }),
      isMainOrder () {
        return this.contractorUuid === this.order?.contractorUuid
      },
      showCancel() {
        if ((this.order.orderStatus === this.STEP.BOOKED || this.order.orderStatus === this.STEP.ALLOCATED) && this.isMainOrder) {
          return true
        }
        else {
          return false
        }
      },
      dropdownTabs() {
        const tabs = [
          {
            icon: 'trash',
            title: 'Отказаться',
            method: () => this.cancelQuery()
          }
        ]

        if (this.order.status === this.STEP.ACCEPTED) {
          tabs.unshift({icon: 'edit', title: 'Назначить другой ресурс', method: () => this.assignAnotherResource()})
        }

        return tabs
      }
    },
    methods: {
      ...mapActions({
        cancelTheOrder: 'account/cancelTheOrder'
      }),
      goToOrder() {
        alert('Пока не сделано')
      },
      cancelQuery() {
        let requestType
        if(this.order.assignmentType === 'STANDARD'){
          requestType = 'carrier-searchers'
        }
        else if(this.order.assignmentType === 'DIRECT' || this.order.assignmentType === 'ANY'){
          requestType = 'orders'
        }
        this.cancelTheOrder(requestType).then( () => {
          this.$notification({type: 'system_notification_success', message: 'Вы отказались от заказа'})
        })
      },
      assignAnotherResource() {
        alert('Уточняется API Назначить другой ресурс')
      }
    }
  }
</script>

<style scoped lang="scss">
  .account-price__header {
    position: relative;
    text-align: center;
    &-title {
      font-size: 12px;
      line-height: 16px;
      letter-spacing: 1.6px;
      text-transform: uppercase;
      color: $shale-gray;
    }
    &-number{
      cursor: pointer;
      color: $color-blue-smalt;
    }
    &-menu {
      position: absolute;
      top: 0;
      right: 0;
    }
  }
</style>
